package org.testinfinispan;

import java.io.Serializable;

import javax.persistence.Cacheable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

@Entity
@Table(name = "employee2")
@Cacheable
@Cache(usage=CacheConcurrencyStrategy.TRANSACTIONAL)
public class Employee implements Serializable{
	private static final long serialVersionUID = -3369070735594176751L;

	@Id
	@GeneratedValue
	@Column(name = "Emp_code")
	private Integer EmpCode;
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((EmpCode == null) ? 0 : EmpCode.hashCode());
		result = prime * result + ((EmpName == null) ? 0 : EmpName.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Employee other = (Employee) obj;
		if (EmpCode == null) {
			if (other.EmpCode != null)
				return false;
		} else if (!EmpCode.equals(other.EmpCode))
			return false;
		if (EmpName == null) {
			if (other.EmpName != null)
				return false;
		} else if (!EmpName.equals(other.EmpName))
			return false;
		return true;
	}

	@Column(name = "Emp_name")
	private String EmpName;

	public int getEmpCode() {
		return EmpCode;
	}

	public void setEmpCode(int empCode) {
		EmpCode = empCode;
	}

	public String getEmpName() {
		return EmpName;
	}

	public void setEmpName(String empName) {
		EmpName = empName;
	}
	
}
