package org.testinfinispan.util;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.util.concurrent.atomic.AtomicReference;

import javax.transaction.Status;
import javax.transaction.SystemException;
import javax.transaction.Transaction;
import javax.transaction.TransactionManager;
//import com.arjuna.ats.jta.TransactionManager;
import org.infinispan.transaction.tm.DummyTransactionManager;

public class TestTransanctionManagerUtils {
    private static AtomicReference<TransactionManager> managerRef = 
        new AtomicReference<TransactionManager>();
  
	public static TransactionManager getManager() throws Exception {
	
		TransactionManager manager = managerRef.get();
		if (manager!= null) return manager;
		
		if (manager == null) {
	        managerRef.set(new DummyTransactionManager());
	        manager=managerRef.get();
	        System.err.println("Transaction manager Didn't work");
	    }
	    System.err.println("Failed Transaction");
	    return manager;
	    
		/*Class<?> managerClass;
		managerClass=Class.forName("com.arjuna.ats.jta.TransactionManager");
		
	       try {
	            Method m = managerClass.getMethod("transactionManager");
	            
	            if (!TransactionManager.class.isAssignableFrom(m.getReturnType())) {
	                throw new IllegalArgumentException("Class " + managerClass + 
	                    " has method named transactionManager but doesn't return" +
	                    "a TransactionManager class instance");
	            }
	            
	            if (Modifier.isStatic(m.getModifiers())) {
	                try {
	                    return (TransactionManager)m.invoke(null);
	                }
	                catch (IllegalAccessException e) {
	                    throw new IllegalArgumentException(e);
	                }
	                catch (InvocationTargetException e) {
	                    throw new IllegalArgumentException(e);
	                }
	            }
	            
	    	    
	        }
	        catch (NoSuchMethodException e) {
	            throw new IllegalArgumentException(e);
	        }
	        throw new IllegalArgumentException("Provided class " + managerClass + 
	            " either is not an instance of " + TransactionManager.class + 
	            " or doesn't have a static method named transactionManager that" +
	            " returns a TransactionManager instance");
*/

	}
    static void registerTransactionManager(TransactionManager manager) {
        managerRef.set(manager);
    }
    
}
